#ifndef _DAPS_H
#define _DAPS_H        

struct vk;
struct sk;

int KGen(struct vk **vk, struct sk **sk, int bits);
void vk_release(struct vk *vk);
void sk_release(struct sk *sk);
size_t sig_length(const struct vk *vk);

void Sign(const struct sk *sk, const struct vk *vk, char *sig, const char *subj, size_t slen, const char *msg, size_t mlen);

int Ver(const struct vk *vk, const char *sig, const char *subj, size_t slen, const char *msg, size_t mlen);

struct sk* skExtract(const struct vk *vk, const char *subj, size_t slen, const char *sig1, const char *msg1, size_t mlen1, const char *sig2, const char *msg2, size_t mlen2);

#endif  /* _DAPS_H */
